#!/usr/bin/perl
#<code>
#  <owner name="Zealic" email="rszealic@gmail.com"/>
#  <version>1.0</version>
#  <timestamp>2008-3-30</timestamp>
#</code>

# Initial
$len = scalar @ARGV;
if ($len >= 2 and $len <= 3)
{
	if($len == 3)
	{
		if(index(@ARGV[0], "-") != 0) {showHelp(); exit(101);}
	    $ignoreCase = index(@ARGV[0], "i", 1) != -1;
	    $nesting = index(@ARGV[0], "n", 1) != -1;
	}
    $dictFile = @ARGV[$len - 2];
    $templateFile = @ARGV[$len - 1];
}
else # Show help
{
	showHelp();
	exit(102);
}

# Open files
open(FDICT, $dictFile) or die("Can't open file $dictFile.");
open(FTPL,  $templateFile) or die("Can't open file $templateFile.");

# Parse dict
{
	@lines = <FDICT>;
	foreach $line(@lines)
	{
		if($line =~ /\w+=/)
		{
			$key = substr($line, 0, $+[0] - 1);
			$value = substr($line, $+[0], length($line) - $+[0]);
			chomp($value);
			$dict{$key} = $value;
		}
	}
}

# Replace and output
{
	@contents = <FTPL>;
	foreach $line(@contents)
	{
		while($line =~ /\$\(\w+\)/)
		{
			local $old = $line;
			while (($key, $value) = each %dict) 
			{
				if($ignoreCase)
				{
					$line =~ s/\$\($key\)/$value/gi;
				}
				else
				{
					$line =~ s/\$\($key\)/$value/g;
				}
			}
			if($old eq $line) {last;}
			unless($nesting) {last;}
		}
		print "$line"; 
	}
}

sub showHelp()
{
	print(
'StringTemplate 1.0
Copyright 2008 Zealic, All rights reserved.
Contact Me : e-mail:rszealic@gmail.com

Usage :
  StringTemplate.pl : [-[i][n]] <DictFile> <TemplateFile>

  Options :
    i : IGNORECASE variable for case-insensitive matches.
    n : Nest replacement.
');
}
